;
;  PS2DRV is free software; you can redistribute it and/or modify
;  it under the terms of the GNU General Public License (as published by
;  the Free Software Foundation; either version 2,or (at your option) any
;  later version. ) or HIOCS PLUS Licence; 
;  
;

; !!!!!!!!!!!!!!!!!!!!!!!!!!!!  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;
; CZXGPL̏ꍇIOCS R[E荞݃[`ɂ 
; libgcc Ȃǂ̂悤GPL̃NOKpB
;
; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	.title	PS/2 MOUSE DRIVER (ps2drv.s)

* Include Files ----------------------- *

		.include	doscall.mac
		.include	iocscall.mac
		.include	ps2drv.equ

* Global Symbols ---------------------- *

		.xref	dev_header

		.xref	sccbrcv
		.xref	msctrlsetA, msctrlsetB
		.xref	ms_init, ms_vcs
		.xref	joyget

* Macros ------------------------------ *

PRINT:		.macro	adr
		pea	adr
		DOS	__PRINT
		addq.l	#4,sp
		.endm

* Text Section ------------------------ *

		.text
		.even
checkstr:
		.dc.b	DEVICE_ID, version		*(16bytes)
		.dc.b	'PS2MSDRV'



;===============================================
;	XgeW[`			
;===============================================

		.cpu	68000
dev_strtgy::
		move.l	a5,(dev_rqhptr)			*NGXgwb_ւ̃|C^
		rts

;===============================================
;	荞݃[`			
;===============================================

		.cpu	68000
dev_intrpt::
		movem.l	d0-d7/a0-a6,-(sp)		*
		movea.l	(dev_rqhptr,pc),a5		*
		moveq	#0,d0				*
		move.b	(2,a5),d0			*R}hR[h
.if 0	/* .if CPU>=68020 */
		move	(dev_jmptbl,pc,d0.w*2),d0
		jsr	(dev_jmptbl,pc,d0.w)
		ror	#8,d0
		move	d0,(3,a5)
.else
		add	d0,d0
		move	(dev_jmptbl,pc,d0.w),d0
		jsr	(dev_jmptbl,pc,d0.w)
		addq.l	#3,a5
		move.b	d0,(a5)+	*G[R[h	 (L)
		move	d0,-(sp)	;lsr	#8,d0
		move.b	(sp)+,(a5)	;move.b	d0,(a5)	*(H)
.endif
		movem.l	(sp)+,d0-d7/a0-a6
		rts
		.cpu	CPU

dev_rqhptr:	.ds.l	1		*NGXgwb_ւ̃|C^
dev_jmptbl:				*R}h[`̃Wve[u
	.dc	dev_init-dev_jmptbl	*
	.dc	dev_err-dev_jmptbl	*G[
	.dc	dev_err-dev_jmptbl	*gp
	.dc	dev_iocin-dev_jmptbl	*IOCTRLɂ
	.dc	dev_in-dev_jmptbl	*
	.dc	dev_in-dev_jmptbl	*ǂݓ
	.dc	dev_instat-dev_jmptbl	*̓Xe[^X`FbN
	.dc	dev_flush-dev_jmptbl	*̓obt@NA
	.dc	dev_out-dev_jmptbl	*o(VERIFY OFF)
	.dc	dev_out-dev_jmptbl	*o(VERIFY ON)
	.dc	dev_outstat-dev_jmptbl	*o̓Xe[^X`FbN
	.dc	dev_err-dev_jmptbl	*gp
	.dc	dev_iocout-dev_jmptbl	*IOCTRLɂo
*===============================================*
*	G[					*
*===============================================*
dev_err:
		move	#$5003,d0	*R}hR[hs
		rts
*===============================================*
*	Xe[^X`FbN			*
*===============================================*
dev_instat:
		moveq	#1,d0
		rts

*========================
*	IOCTRL
*========================
dev_in:
dev_iocin:
		move.l	(18,a5),d0	*	]oCg
		moveq	#IOCTRLSIZE,d1	*
		cmp.l	d1,d0		*
		bls	dev_iocin0	*(o[W`FbNLɂ邽)

		move.l	d1,d0		*	
dev_iocin0:
		movea.l	(14,a5),a0	* ]obt@AhX
		lea	(IOCTRLDATA,pc),a1
		subq.l	#1,d0
@@:
		move.b	(a1)+,(a0)+	*IOCTRLf[^]
		dbra	d0,@b
dev_outstat:
dev_flush:
		moveq	#0,d0
		rts

*========================
*	IOCTRLo
*========================
dev_out:
dev_iocout:
		move.l	(18,a5),d0		*	]oCg
		moveq	#IOCTRLSIZE,d1		*
		cmp.l	d1,d0			*
		bne	dev_err			*

		movea.l	(14,a5),a6		*]obt@AhX
		movea.l	a6,a0			*
		lea	(IOCTRLDATA,pc),a1	*
		moveq	#16-1,d0	*
dev_iocout1:
		cmpm.b	(a0)+,(a1)+		*o[Wr
		dbne	d0,dev_iocout1		*
		bne	dev_err			*

		lea	(IOCSMSFLG-IOCTRLDATA,a6),a0
		lea	(IOCSMSFLG,pc),a1	*
		bsr	restorevect		*IOCS/DOSxN^ɖ߂
		bne	dev_iocout9		*xN^ύXĂ
		bsr	setvect			*IOCS/DOSxN^ύX

		moveq	#0,d0
		move	d0,(IOCTRLERR-IOCTRLDATA,a6)
		rts
dev_iocout9:				*xN^ύXĂꍇ
		move	#-1,(IOCTRLERR-IOCTRLDATA,a6)
		moveq	#0,d0
		rts


*===============================================*
*	IOCS/DOSR[xN^ύX		*
*===============================================*

setvect:
	tst.b	(a1)			* IOCS}EXxN^
	bne	setvect10		* łɕύXĂ
	move.b	(a0),(a1)		* 
	beq	setvect10		* ύXȂ

	lea	(iocsmtbl,pc),a3	*
	bsr	chgvecttbl_iocs		*IOCSxN^ύX

	lea	(OLDMSCVC,pc),a2	*
	clr.l	(a2)			*

*------------------------------------------------------------------------
*	}EX̏[`HIOCSȂǂɂĕύXĂ\
*	̂ROMAhXォǂ͍̔s킸AɎ
*	[`tbNĂ邩ǂ𔻒肷B
*------------------------------------------------------------------------

	lea	(msctrlsetA,pc),a2	* 
	move.l	(MSTADR),a3		* timer-C }EXMv
	cmpa.l	a2,a3			*
	beq	setvect5		* }EXMv͕ύXĂ
	lea	(sccbrcv,pc),a3		*
	move.l	a2,a3			*
	beq	setvect5		* SCCM͕ύXĂ

*-------- }EXMv̕ύX -------*

	move	sr,d0			* 
	ori	#$0700,sr		*==========荞݋֎~==========
	lea	(OLDMSCVC,pc),a2	*
	move.l	(MSTADR),(a2)		* timer-C }EXMv
	lea	(msctrlsetA,pc),a2	* 
	move.l	a2,(MSTADR)		* 
	clr.b	(MSCTRLFLG)		* 
	lea	(OLDSCCBVC,pc),a2	* 

*-------- SCCB M̕ύX ------------*

	move.l	(SCCBRCVEC),(a2)+	*SCC-BM
	move.l	(SCCBRCVEC2),(a2)	*
	lea	(sccbrcv,pc),a2		*
	move.l	a2,(SCCBRCVEC)		*
	move.l	a2,(SCCBRCVEC2)		*
	move	d0,sr			*==========荞ݕA==========
setvect5:
	moveq	#0,d1			*
	IOCS	__SETMSADR		*}EXJ[\\AhXύX
setvect10:
	moveq	#0,d0
	rts
chgvecttbl2:
	rts

*	IOCS/DOSxN^ύX

chgvecttbl_iocs:			*
		lea	($400),a2	*
chgvecttbl:				*
		move.l	a3,d1		*
chgvecttbl1:				*
		move	(a3)+,d0	*
		bmi	chgvecttbl2	*
		add	d0,d0		*
		add	d0,d0		*
		movea.l	d1,a4		*
		adda	(a3)+,a4	*	ύXAhX
		move.l	(a2,d0.w),(a3)+	*	݂̃xN^ۑ
		move.l	a4,(a2,d0.w)	*	xN^ύX
		bra	chgvecttbl1	*

*===============================================*
*	IOCS/DOSR[xN^̒lɖ߂	*
*===============================================*
*	AxN^ύXĂȂǂ`FbN
*=========================================================

restorevect:
	tst.b	(a1)			*IOCS}EXxN^
	beq	restorevect5		*ύXĂȂ
	tst.b	(a0)
	bne	restorevect5		*̒lɖ߂Ȃ

	lea	(iocsmtbl,pc),a3	*
	bsr	chkvecttbl_iocs		*
	bne	restorevect99		*

	move.l	(OLDMSCVC,pc),d0	*
	beq	restorevect5		*}EXMv/SCCM͕ύXĂȂ

	move.l	(MSTADR),a3		*
	lea	(msctrlsetA,pc),a2	* {̑}EXMv[`
	cmpa.l	a3,a2			* 
	beq	restorevect5		*
	lea	(msctrlsetB,pc),a2	* L[{[h}EXMv[`
	cmpa.l	a3,a2			*
	bne	restorevect99		*

restorevect5:
	lea	(sccbrcv,pc),a2
	cmpa.l	(SCCBRCVEC),a2
	bne	restorevect99
	cmpa.l	(SCCBRCVEC2),a2
	bne	restorevect99

restorevect54:
	tst.b	(a1)			*IOCS}EXxN^
	beq	restorevect60		*ύXĂȂ
	move.b	(a0),(a1)
	bne	restorevect60		*̒lɖ߂Ȃ

	lea	(iocsmtbl,pc),a3
	bsr	rstvecttbl_iocs
	move.l	(OLDMSCVC,pc),d0
	beq	restorevect55		*}EXMv/SCCM͕ύXĂȂ

	move	sr,d0
	ori	#$0700,sr		*荞݋֎~
	move.l	(OLDMSCVC,pc),(MSTADR)	*timer-C }EXMv
	clr.b	(MSCTRLFLG)
	move.l	(OLDSCCBVC,pc),(SCCBRCVEC)	*SCC-BM
	move.l	(OLDSCCBVC2,pc),(SCCBRCVEC2)
	move	d0,sr
restorevect55:
	moveq	#0,d1
	IOCS	__SETMSADR		*}EXJ[\\AhXύX

restorevect60:
	moveq	#0,d0
	rts

restorevect99:
	moveq	#-1,d0
	rts

*	ύXIOCS/DOSxN^ɖ߂

rstvecttbl_iocs:
		lea	($400),a2
		bra	rstvecttbl
rstvecttbl1:
		add	d0,d0
		add	d0,d0
		addq.l	#2,a3
		move.l	(a3),(a2,d0.w)
		clr.l	(a3)+
rstvecttbl:
		move	(a3)+,d0
		bpl	rstvecttbl1
		rts

*====================================================
*	IOCS/DOSxN^ύXĂȂׂ
*====================================================

chkvecttbl_iocs:
	lea	($400),a2	* IOCSxN^AhX̃[h
chkvecttbl:
	move.l	a3,d1		
chkvecttbl1:			*
	move	(a3)+,d0	* callno
	bmi	chkvecttbl2	* -1ȂI

	add	d0,d0		*
	add	d0,d0		* callno*4
	movea.l	d1,a4		
	adda	(a3)+,a4	* ϊIOCSAhX
	addq.l	#4,a3		
	cmp.l	(a2,d0.w),a4	* 
	beq	chkvecttbl1	*

	moveq	#-1,d0		*xN^ύXĂ
	rts
chkvecttbl2:
	moveq	#0,d0		*xN^͕ύXĂȂ
	rts

*===============================
*	IOCTRLpf[^		
*===============================

* PS2CONVp̃f[^

		.even
IOCTRLDATA:	.dc.b	DEVICE_ID, version	*(16bytes)
IOCTRLERR:	.ds	1			*(IOCTRL̃G[R[h)
TOPADR:		.dc.l	0	*풓擪AhX(foCXhCoo^Ȃ0)

IOCSMSFLG:	.dc.b	0	*IOCS}EXxN^ύXtO
VECTFLGSIZE:	.equ	*-IOCSMSFLG
		.even
MSKIND:		.dc	0	*======zB[}EX̎==========
				* 0: ʏ̃Ce}EX		(4)
				* 1: }`XN[}EX		(4)
				* 2: CeGNXv[[}EX	(4)
				* 3: JERRY MOUSE			(3)
				*====================================
MSSHIFT::	.dc	4	* Vtg̗
MSSPEED::	.dc	3	*}EXJ[\ړx( 1 ` 3 ` 4 ᑬ)
RLSYNC::	.dc.b	0	* ROLL UP/DOWNƃzB[VNB
IOCTRLEND:
IOCTRLSIZE:	.equ	IOCTRLEND-IOCTRLDATA
		.even

LINKPTR:	.ds.l	1	* foCXhCoN|C^
OLDMSCVC:	.ds.l	1	* 
OLDSCCBVC:	.ds.l	1	* SCC-B M
OLDSCCBVC2:	.ds.l	1	* (SCC-B M)

*	IOCSxN^e[u

viocsm:		.macro	callno,addr
		.dc	callno,addr-iocsmtbl
old_&addr::
		.ds.l	1
		.endm

iocsmtbl:
	viocsm	__SETMSADR,ms_vcs
	viocsm	__MS_INIT,ms_init
	viocsm	__JOYGET,joyget
	.dc	-1

		.cpu	CPU

dev_init9:					*R}hCo^̏ꍇ
		lea	(dev_header,pc),a0	*
		lea	(dev_end,pc),a2		*
		suba.l	a0,a2			* foCXhCȍ풓TCY߂
		clr	-(sp)			* IR[h (=0)
		move.l	a2,-(sp)		* 
		DOS	__KEEPPR			* 풓

*=======================================
*	풓			
*=======================================

dev_end:					* ȍ~͏풓Ȃ

*=================================================
*	foCXhCȍ
*=================================================
		.cpu	68000
dev_init:
.if CPU==68000					*
		bsr	check_real		*
.endif
		PRINT	(title_msg,pc)		* ^Cg̕\
		lea	(FLAG_DEV,pc),a0	* 
		st	(a0)			* NtOZbg
		lea	(dev_jmptbl,pc),a0	*
		move	#dev_err-dev_jmptbl,(0,a0)

		lea	(IOCSMSFLG,pc),a0	*
		moveq	#VECTFLGSIZE-1,d0	*
dev_init1:
		st	(a0)+			* SxN^ύX(ftHg)
		dbra	d0,dev_init1		*

		movea.l	(18,a5),a1		* p[^|C^
		bsr	dev_param		* p[^߂
		bmi	dev_init_err		*

		move.b	(FLAG_R,pc),d0		* IvV -r H
		bne	dev_init_err		* foCXhCogݍݎ/r͎ws
		lea	(VECTFLG,pc),a0
		lea	(IOCSMSFLG,pc),a1
		moveq	#VECTFLGSIZE-1,d0
dev_init2:
		move.b	(a1),(a0)+		* 
		sf	(a1)+			* 
		dbra	d0,dev_init2		* 

		lea	(VECTFLG,pc),a0		* 
		lea	(IOCSMSFLG,pc),a1	* 
		bsr	setvect			* IOCSxN^ύX
		moveq	#0,d6			* 
		bra	dev_init9		* 

		.cpu	68000
dev_init_err:					* ̃G[
		pea	(paramerr_msg,pc)	* 
		bra	@f			* 
dev_init_err_mpu:
		pea	(mpu_err_msg,pc)	* 
@@:
		DOS	__PRINT			* 
		addq.l	#4,sp			* 
		move	#$500c,d0		* 
		rts				* 

.if CPU==68000
check_real:
		.dc	19001,232,57355,26496,20085
.endif

*===============================================*
*	R}hCɂN		*
*===============================================*

		.cpu	68000
cmd_exec:
		bra.s	@f		*
		.dc.b	'#HUPAIR',0	* HUPAIR ΉtO
@@:
		movea.l	(8,a0),sp	*ubNIAhX{PX^bNɂ
		clr.l	-(sp)		*
		DOS	__SUPER		*X[p[oCU[hɓ
		addq.l	#4,sp		*
.if CPU==68000 
		bsr	check_real	* ͂ȂɁHH
.endif
		PRINT	(title_msg_2,pc)
.if CPU==68030
		cmpi.b	#2,(MPUTYPE)
		bcs	mpuerr
.endif
		.cpu	CPU

		lea	(16,a0),a5		 *vO̐擪AhX
		lea	(dev_jmptbl,pc),a0	 	*
		move	#dev_err-dev_jmptbl,(a0)	*

		pea	(DATABUF,pc)		*
		move	#-2,-(sp)		*
		DOS	__GET_PR		*g̃Xbh̏𓾂
		addq.l	#6,sp		
		tst.l	d0		
		ble	cmd_exec1		*XbhOG[̏ꍇ

		pea	(bgerr_msg,pc)		*
		bra	errout			*afł̎s͕s\
cmd_exec1:
		clr	-(sp)			*<+08(Human v1.0x̃oO)
		pea	(dev_name,pc)		*
		DOS	__OPEN			* '@MOUSE  'I[v
		addq.l	#6,sp			*
		move.l	d0,d7			*
		bmi	cmd_exec50		*   I[vłȂco^̏ꍇ

		move	d7,-(sp)		*   
		clr	-(sp)			*   mode 0: u̎擾
		DOS	__IOCTRL		*   '@MOUSE'̑u𓾂
		addq.l	#4,sp			*   
		move	d0,d1			*	<+08

		move	d7,-(sp)
		DOS	__CLOSE			*    '@MOUSE'N[Y
		addq.l	#2,sp
		moveq	#-1,d7			*(t@CfBXNv^𖳌ɂ)
*
*		andi	#$c03f,d1		*
*		cmpi	#$c020,d1		*(׸޲/IOCTRL/RAW MODE)
*		bne	cmd_exec50		* u񂪈Ⴄ(IOCS.Xo^ς݂̏ꍇ)
*
		move	#1,-(sp)		*x͏݃I[v
		pea	(dev_name,pc)		*
		DOS	__OPEN			*'@MOUSE'ēxI[v
		addq.l	#6,sp			*
		move.l	d0,d7			*
		bmi	cmd_exec50		*   KI[vł͂Ô

		pea	(IOCTRLSIZE).w		* 
	 	lea	(IOCTRLDATA,pc),a0	*	<+06
	 	clr.l	(a0)			* 
	 	pea	(a0)			* 
		move	d7,-(sp)		* 
		move	#2,-(sp)		* mode 2:foCXhCo̒ړ
		DOS	__IOCTRL		* ݂HIOCSp[^𓾂
		lea	(12,sp),sp		* 

		lea	(IOCTRLDATA,pc),a0	* 
		lea	(checkstr,pc),a1	* 
		moveq	#16/4-1,d0		* 
cmd_exec2:
		cmpm.l	(a0)+,(a1)+		* o[W`FbNpr
		dbne	d0,cmd_exec2		*
		bne	vererr			* o[WႤ

*(foCXhCoԂ畜Aꍇ)
		lea	(IOCSMSFLG,pc),a0	*
		moveq	#VECTFLGSIZE-1,d0	*
cmd_exec3:
		st	(a0)+
		dbra	d0,cmd_exec3
cmd_exec4:
		bsr	cmd_param	*p[^̉
		bne	usage		*R}hCɌ肪

		move.b	(FLAG_M,pc),d0
		bne	alrromerr		*-mXCb`	<+03
		move.b	(FLAG_R,pc),d0
		bne	cmd_rels		*-rXCb`

		bsr	ioctrl_write		*HIOCSp[^ݒ肷
cmd_exec5:
		move	(IOCTRLERR,pc),d0	*
		bne	vecterr			*xN^ύXĂ
		bra	exit			*


ioctrl_write:
		pea	(IOCTRLSIZE).w		*
		pea	(IOCTRLDATA,pc)		*
		move	d7,-(sp)		*
		move	#3,-(sp)		*  mode 3:foCXhCoւ̒ڏo
		DOS	__IOCTRL		*  HIOCSp[^ݒ肷
		lea	(12,sp),sp		*
		rts

*======================================
*	-rXCb`(풓)
*======================================
cmd_rels:
	lea	(IOCSMSFLG,pc),a0	*
	moveq	#VECTFLGSIZE-1,d0	*
cmd_rels1:
	sf	(a0)+			*SxN^𕜋A
	dbra	d0,cmd_rels1

	bsr	ioctrl_write		*HIOCSp[^ݒ肷

	move	(IOCTRLERR,pc),d0
	bne	vecterr			*xN^ύXĂ

	move.l	(TOPADR,pc),d0		*
	beq	rels_exit		*foCXhCoo^̏ꍇ
	movea.l	d0,a0			*

	movea.l	(LINKPTR-dev_header+$f0,a0),a1	*ÕN|C^
	move.l	($f0,a0),(a1)		*'@IOCS'foCXhCoNO
	move.l	d0,-(sp)
	DOS	__MFREE
*	addq.l	#4,sp
*	tst.l	d0
	move.l	d0,(sp)+
	bmi	relserr			*풓JłȂ
	bra	rels_exit

*==================================================
*	PS2DRV.Xgݍ܂ĂȂꍇ
*==================================================
cmd_exec50:
	lea	(IOCSMSFLG,pc),a0
	moveq	#VECTFLGSIZE-1,d0
cmd_exec51:
	st	(a0)+			*SxN^ύX(ftHg)
	dbra	d0,cmd_exec51

	bsr	cmd_param		*p[^̉
	bne	usage			*R}hCɌ肪

	move.b	(FLAG_R,pc),d0
	bne	nostayerr		*-rXCb`

	move.l	d1,-(sp)
	lea	(TOPADR,pc),a1
	move.l	a5,(a1)
	bsr	sealink			*N|C^̏I[T
	lea	LINKPTR(pc),a2
	lea	(dev_header,pc),a0
	move.l	a1,(a2)
	move.l	a0,(a1)			*N|C^Ȃ

	lea	(VECTFLG,pc),a0		*
	lea	(IOCSMSFLG,pc),a1	*
	moveq	#VECTFLGSIZE-1,d0	*
cmd_exec52:
	move.b	(a1),(a0)+
	sf	(a1)+
	dbra	d0,cmd_exec52

	lea	(VECTFLG,pc),a0		*
	lea	(IOCSMSFLG,pc),a1	*
	bsr	setvect			*xN^ύX

	move.l	(sp)+,d1
	moveq	#-1,d6
	bra	dev_init9		* 풓

relserr:				*JłȂ
	PRINT	(relserr_msg,pc)	*(Ǘ|C^ُ̈)
relserr1:
	bra	relserr1

vererr:					*풓ƃo[WႤ
	pea	(vererr_msg,pc)
	bra	errout

nomemerr:				*tHgt@Cǂݍݗps
	pea	(nomem_msg,pc)
	bra	errout

nostayerr:				*풓ĂȂ
	pea	(nostay_msg,pc)
	bra	errout

vecterr:				*xN^ύXĂ
	pea	(vecterr_msg,pc)
	bra	errout
mpuerr:
	pea	(mpu_err_msg,pc)
	bra	errout

usage:					*gp@\ďI
		bpl	@f
		PRINT	(paramerr_msg,pc)
@@:
		pea	(usage_msg,pc)
errout:					*G[o͂ďI
		DOS	__PRINT
		addq.l	#4,sp

		bsr	close_iocs
		move	#-1,-(sp)
		DOS	__EXIT2

rels_exit:
		PRINT	(rels_msg,pc)
exit:
		bsr	close_iocs
		DOS	__EXIT		

close_iocs:
		move	d7,-(sp)
		bmi	@f
		DOS	__CLOSE		*
@@:
		addq.l	#2,sp
		rts

*	NULfoCXAN|C^̏I[T

sealink::
		lea	($6800),a1
sealink1:
	cmpi	#'NU',(a1)+		*Human'NUL     'To
	bne	sealink1
	cmpi.l	#'L   ',(a1)
	bne	sealink1
	cmpi	#'  ',(4,a1)
	bne	sealink1
	lea	(-16,a1),a1		*NULfoCX̃N|C^
sealink2:
	movea.l	(a1),a1			*N|C^Pǂ
	tst.l	(a1)
	bpl	sealink2
	rts

alrromerr:
		pea	(alrrom_msg,pc)
		bra	errout

.if 0
check_mpu_type:
		move.l	a1,-(sp)
		lea	(MPUTYPE),a1
		IOCS	__B_BPEEK
		subq.b	#1,d0
		movea.l	(sp)+,a1
		rts
.endif


*=======================================*
*	p[^̉		*
*=======================================*

cmd_param:				*R}hCp[^Xg
		pea	(1,a2)		*
		bsr	GetArgCharInit	*
		addq.l	#4,sp		*
		bra	@f
dev_param:				*foCXhCop[^
		tst.b	(a1)+		*
		bne	dev_param	*
		lea	(ArgPtr,pc),a0	*
		move.l	a1,(a0)		*
		st	(a0)		*
@@:
param1:
		bsr	GetArgChar	*
		tst.l	d0		*
		beq	param9		*
		bmi	param1		;""

		moveq	#-1,d3		*-[XCb`]
		cmpi.b	#'-',d0
		beq	param2
		moveq	#0,d3		*+[XCb`] c@\w𔽓]
		cmpi.b	#'+',d0		*
		beq	param2

		moveq	#90-2,d1
@@:
		bsr	GetArgChar
		tst.b	d0
		dbeq	d1,@b
		beq	param1
		bra	param8			;t@C
param2:
		bsr	GetArgChar
		tst.b	d0
		beq	param8			;-/+̂
next_option:
		tst.b	d0
		beq	param1
		cmpi.b	#'?',d0
		beq	param_h
		ori.b	#$20,d0
		lea	(param_table-2,pc),a0
@@:
		addq.l	#2,a0
		move	(a0)+,d1
		beq	param8
		cmp.b	d0,d1
		bne	@b
		adda	(a0),a0
		jmp	(a0)
param8:
		moveq	#-1,d0		*p[^̎wɌ肪
		rts

param_table:
		.irpc	%a,hkmr
		.dc	'&%a',param_%a-$
		.endm
		.dc	0

param_h:
		moveq	#1,d0		*gp@\
param9:
		rts			;d0.l=0

param_m:				*-m
		bsr	GetArgChar
		cmpi.b	#'s',d0
		beq	param_ms
		cmpi.b	#'S',d0
		beq	param_ms
		cmpi.b	#'h',d0
		beq	param_mh
		cmpi.b	#'H',d0
		beq	param_mh
		cmpi.b	#'k',d0
		beq	param_mk
		cmpi.b	#'K',d0
		beq	param_mk

		lea	(FLAG_M,pc),a0
		st	(a0)
		bra	next_option

param_ms:					*-ms[0/1]	<+08
		lea	(IOCSMSFLG,pc),a0
		bsr	GetArgChar
		cmpi.b	#'0',d0
		bcs	param_ms2
		beq	param_ms0
		cmpi.b	#'4',d0
		bhi	param_ms2

		moveq	#'5',d1			;-ms1`-ms4 }EXJ[\ړx̎w
		sub	d0,d1
		bsr	GetArgChar
param_ms1:
		st	(a0)
		lea	(MSSPEED,pc),a0
		move	d1,(a0)			;1`4  4`1
		bra	next_option
param_ms2:
		moveq	#3,d1
		tst.b	d3
		bne	param_ms1		;-ms = -ms2

		st	(a0)			;+ms tbN̂
		bra	next_option
param_ms0:
		sf	(a0)			;-ms0 ROMɖ߂
		bra	paramsw9


param_mh:					;-mh[0/1]
		moveq	#$1f,d2			;5MHz
		bsr	check_param01
		beq	@f
		moveq	#$2f,d2			;7.5MHz
@@:
		move	sr,-(sp)
		ori	#$700,sr
		lea	(_SCCCMD_B),a0
		tst.b	(a0)			;ǂ
		moveq	#14,d1
		move.b	d1,(a0)
		move.b	#%000_0001_0,(a0)	;{[[gWFl[^~

		move.b	#12,(a0)
		move.b	d2,(a0)			;tc()
		lsr	#8,d2
		move.b	#13,(a0)
		move.b	d2,(a0)			;tc()

		move.b	d1,(a0)
		move.b	#%000_0001_1,(a0)	;{[[gWFl[^
		move	(sp)+,sr
		bra	next_option

param_mk:
		lea	(MSKIND,pc),a0
		bsr	GetArgChar
		cmpi.b	#'3',d0
		beq	param_mk3
		bcs	param_mk1
		cmpi.b	#'0',d0
		bcc	param_mk1

param_mk3:	moveq	#3,d0
		move	d0,(a0)+	* }EX̎ނݒ
		move	d0,(a0)		* Vtg̐ݒ
		bra	@f

param_mk1:	moveq	#'0',d1		
		sub.b	d1,d0		
		move	d0,(a0)+	* }EX̎ނݒ
		move	#4,(a0)		* Vtg̐ݒ
@@:		lea	(ms_msg_table,pc),a0
		add	d0,d0
		adda	d0,a0
		adda	(a0),a0
		PRINT	(a0)
		bra	paramsw9

ms_msg_table:
		.irpc	%d,0123
		.dc	ms_msg%d-$
		.endm
		.dc	0

param_k:
		lea	(RLSYNC,pc),a0
		bsr	check_param01
		sne	(a0)
		tst.b	(a0)
		beq	@f
		PRINT	(wheel_msg,pc)
@@:		bra	next_option

* -x -x1 +x0	d1.b = -1
* +x -x0 +x1	d1.b =  0
check_param01:
		move.b	d3,d1
		bsr	GetArgChar
		cmpi.b	#'1',d0
		beq	@f			;-x=-x1A+x=+x1
		cmpi.b	#'0',d0
		bne	9f
		not.b	d1			;-x0=+xA+x0=-x
@@:		bsr	GetArgChar
9:		tst.b	d1
		rts

param_r:				*-r
		lea	(FLAG_R,pc),a0

paramset:
		st	(a0)

paramsw9:
		bsr	GetArgChar
		bra	next_option

paramsw:
		move.b	d3,(a0)
paramsw1:
		bsr	GetArgChar
paramsw2:
		cmpi.b	#'1',d0
		beq	paramsw9
		cmpi.b	#'0',d0
		bne	next_option

		not.b	(a0)
		bra	paramsw9

* HUPAIRfR[h ------------------------------ *

GetArgChar:
		movem.l	d1/a0-a1,-(sp)
		moveq	#0,d0
		lea	(ArgPtr,pc),a0
		movea.l	(a0),a1
		move.b	(a0),d1
		bpl	GetArgChar_next

		move.b	(a1)+,d0
		bne	GetArgChar_end
		tst.b	(a1)
		bne	GetArgChar_abort2
		subq.l	#1,a1
		bra	GetArgChar_end
GetArgChar_next:
		move.b	(a1)+,d0
		beq	GetArgChar_abort
		tst.b	d1
		bne	GetArgChar_inquate
		cmpi.b	#' ',d0
		beq	GetArgChar_separate
		cmpi.b	#"'",d0
		beq	GetArgChar_quate
		cmpi.b	#'"',d0
		bne	GetArgChar_end
GetArgChar_quate:
		move.b	d0,d1
		bra	GetArgChar_next
GetArgChar_end:
		move.l	a1,(a0)
		move.b	d1,(a0)
GetArgChar_abort:
		movem.l	(sp)+,d1/a0-a1
		rts
GetArgChar_inquate:
		cmp.b	d0,d1
		bne	GetArgChar_end
		clr.b	d1
		bra	GetArgChar_next
GetArgChar_separate:
		cmp.b	(a1)+,d0
		beq	GetArgChar_separate
		subq.l	#1,a1
GetArgChar_abort2:
		moveq	#1,d0
		ror.l	#1,d0
		bra	GetArgChar_end

GetArgCharInit:
		movem.l	a0-a1,-(sp)
		movea.l	(12,sp),a1
GetArgCharInit_skip:
		cmpi.b	#' ',(a1)+
		beq	GetArgCharInit_skip
		subq.l	#1,a1
		lea	(ArgPtr,pc),a0
		move.l	a1,(a0)
		movem.l	(sp)+,a0-a1
		rts

* Data Section -------------------------------- *
*	bZ[Wf[^

		.data
dev_name:	.dc.b	'@MOUSE  ',0

title_msg:	.dc.b	CR,LF
title_msg_2:	.dc.b	program, ' version ', version, ' (C)', year, ' ', author, ' ', date, '.', CR, LF,0
crlf_msg:	.dc.b	CR,LF,0

paramerr_msg:	.dc.b	'IvVwɊԈႢ܂.',CR,LF,0
mpu_err_msg:	.dc.b	' MPU ł͎gpł܂.',CR,LF,0

usage_msg:	.dc.b	'usage : ps2drv [option] ',CR,LF
		.dc.b	'	-m	ROM̏Ĉݍs.',CR,LF
		.dc.b	'	-mk[n]	}EX̎ނ̐ݒ(n:0`3 W0).',CR,LF
		.dc.b	'	-ms[n]	}EXJ[\̈ړxw(n:1`4 W2).',CR,LF
		.dc.b	'	-mh	SCCNbN7.5MHz[hɂ.',CR,LF
		.dc.b	'	-k	ROLL UP/DOWN[hɂ.',CR,LF
		.dc.b	'	-h	wv̕\',CR,LF
		.dc.b	0

ms_msg0:	.dc.b	'Ce}EXŏ܂.',CR,LF,0

ms_msg1:	.dc.b	'}`XN[}EXŏ܂.',CR,LF,0

ms_msg2:	.dc.b	'CeGNXv[}EXŏ܂.',CR,LF,0

ms_msg3:	.dc.b	'Jerry',$27,'s}EXŏ܂.',CR,LF,0

wheel_msg:	.dc.b	'zB[ROLL UP/DOWN𓯊܂.',CR,LF,0

bgerr_msg:	.dc.b	'obNOhvZXł̏͂ł܂.',CR,LF,0

vererr_msg:	.dc.b	'PS/2}EXCo ̏풓ƃo[WႢ܂.',CR,LF,0

vecterr_msg:	.dc.b	'xN^Ă܂.',CR,LF,0

rels_msg:	.dc.b	'}EX̏ɖ߂܂.',CR,LF,0

nostay_msg:	.dc.b	'PS/2DRV͑gݍ܂Ă܂.',CR,LF,0

nomem_msg:	.dc.b	'eʂsĂ܂.',CR,LF,0

relserr_msg:	.dc.b	'Ǘ񂪔j󂳂Ă܂I ZbgĂ.'
		.dc.b	$1b,'[>5l',0

alrrom_msg:	.dc.b	'łɃxN^Ă܂.',CR,LF,0

* Block Storage Section -------------- *

		.bss
		.even

ArgPtr:		.ds.l	1

*	ÑXCb`wtO

FLAG_R:		.ds.b	1		*/r  풓
FLAG_M:		.ds.b	1		*/m  v1.1 IOCS _MS_PATST̃oOpb`
FLAG_DEV:	.ds.b	1		*foCXhCoNtO

VECTFLG:	.ds.b	5		*=VECTFLGSIZE

		.even
DATABUF:	.ds.b	$1000		*Gpf[^obt@

		.end	cmd_exec

* End of File ------------------------- *
